#include <iostream>

#include <arc/notify.h>
#include <arc/jobsubmission.h>
#include <arc/standardbrokers.h>
#include <arc/mdsquery.h>
#include <arc/target.h>

int main() {

	SetNotifyLevel(DEBUG);

	Xrsl xrsl("&(executable=/bin/echo)(arguments=\"hello, world\")(runtimeenvironment=\"ATLAS-8.0.5\")(CPUTime=50)");

	try {
		PerformXrslValidation(xrsl);
	} catch(XrslError e) {
		std::cout << e.what() << std::endl;
		return 1;
	}

	// Getting queue info
	std::list<Queue> queueinfo = GetQueueInfo();
	std::list<Target> targets = ConstructTargets(queueinfo, xrsl);
	PerformStandardBrokering(targets);

	try {
		std::string id = SubmitJob(xrsl, targets);
		std::cout << "Job submitted with jobid: " << id << std::endl;
	} catch(XrslError e) {
		std::cout << e.what() << std::endl;
		return 1;
	} catch(JobSubmissionError e) {
		std::cout << e.what() << std::endl;
		return 1;
	}
}
