package se.umu.wsag.client; 

import java.util.Calendar;
import org.apache.axis.message.addressing.EndpointReferenceType;


/**
 * 
 * @author tordsson
 *
 * Test client using the API in ReservationClient, to 
 * create a reservation, commit it, and finally cancel it. 
 */
public class TestClient {	

    
    public static void main(String args[]) {

    	try {
    		if(args.length < 1) {
    			System.err.println("Usage: testClient factoryURI [params]");
    			System.err.println("[params] := #cpus duration early late flex"); 
    			System.exit(1); 
    		}
    		
    		String factoryURI = args[0];
    		Calendar earlyCal, lateCal;
    		int cpus, duration; 
    		boolean flex; 
    		if(args.length == 6) {
    	
    			cpus = Integer.parseInt(args[1]); 
    			duration = Integer.parseInt(args[2]);
    			
    			earlyCal = Calendar.getInstance();
    			long early = Long.parseLong(args[3]); 
    			earlyCal.setTimeInMillis(1000*early);
    			
    			lateCal = Calendar.getInstance(); 
    			long late = Long.parseLong(args[4]);
    			lateCal.setTimeInMillis(1000*late); 
    			
    			flex = Boolean.getBoolean(args[5]); 
    			
    		}
    		else {
    			cpus = 1; 
    			duration = 3600; 
    			earlyCal = Calendar.getInstance();
    			earlyCal.add(Calendar.HOUR, 1); 
    			lateCal = Calendar.getInstance();
    			lateCal.add(Calendar.HOUR, 10); 
    			flex = false;     			    			
    		}
    		
    		
    		ReservationClient client = new ReservationClient();     		
    		
    		
    		System.out.println("Creating reservation and such..."); 
    		EndpointReferenceType epr = client.createReservation(factoryURI,
    				cpus, 
    				earlyCal, 
					lateCal, 
					duration, 
					flex); 	
    		
    		if(epr == null) {
    			System.err.println("Creating failed..."); 
    			System.exit(1); 
    		}
    		
    		/*
    		System.out.println("Committing reservation..."); 
    		client.commitReservation(epr); 
    		
    		
    		System.out.println("Cancelling reservation..."); 
    		client.destroyReservation(epr); 
    		*/
  
    	} catch (Exception e) {
    		System.err.println("Ooops"); 
    		e.printStackTrace(); 
    	}
    }
}

 

