package se.umu.wsag.util; 

import java.io.IOException; 

import java.net.InetSocketAddress;
import java.net.Socket;
import java.util.Iterator;
import java.util.Set;

import org.globus.axis.util.Util;
import org.globus.gsi.GlobusCredential;
import org.globus.gsi.gssapi.GlobusGSSCredentialImpl;
import org.globus.gsi.jaas.JaasSubject;
import org.globus.wsrf.client.ServiceURL;

public class JobSubmissionUtils {
	
	private static int PING_TIMEOUT = 2000; 
	
    static {
        Util.registerTransport(); 
    }
    
    /**
	 * Really ugly way to test if container (or any other service) is running.
	 * Unless a socket can be opened, we assume that the service
	 * is not running.	 
	 * @param resourceHost
	 * @return
	 */
	public static boolean ping(String resourceHost) {
		
		Socket socket = null; 
		try {
			int port = ServiceURL.getDefaultPort();
			InetSocketAddress address = new InetSocketAddress(resourceHost, 
					port);
			socket = new Socket(); 						
			socket.connect(address, JobSubmissionUtils.PING_TIMEOUT); 
			socket.close(); 
		} 
		catch (IOException e) {
			if(socket != null) {
				try {
					socket.close(); 
				} catch (Exception err) {}
			}				
			return false; 
		}
		
		return true; 
	}
    
    /**
     * Gets the globus credential used by the service, 
     * if user specified GSISecureConversation with delegation, 
     * the delegated credential will be returned. 
     * @return
     * @throws Exception
     */
    public static GlobusCredential getDelegatedCredential() throws Exception {
    	Set s = JaasSubject.getCurrentSubject().getPrivateCredentials(); 
    	Iterator it = s.iterator(); 
    	GlobusGSSCredentialImpl cred = (GlobusGSSCredentialImpl) s.toArray()[0]; 
    	GlobusCredential globusCreds = cred.getGlobusCredential(); 
    	return globusCreds; 
    }
    
}

 

